// TestDialogBox.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "TestDialogBox.h"
#include "PasswordDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define MT4_EXPFUNC __declspec(dllexport)
//
//TODO: If this DLL is dynamically linked against the MFC DLLs,
//		any functions exported from this DLL which call into
//		MFC must have the AFX_MANAGE_STATE macro added at the
//		very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

// CTestDialogBoxApp

BEGIN_MESSAGE_MAP(CTestDialogBoxApp, CWinApp)
END_MESSAGE_MAP()


// CTestDialogBoxApp construction

CTestDialogBoxApp::CTestDialogBoxApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CTestDialogBoxApp object

CTestDialogBoxApp theApp;

MT4_EXPFUNC void __stdcall Hello(char* say)
{

	if ( say )
	{
		int len = strlen(say)+1;
		wchar_t *wText = new wchar_t[len];
		if ( wText == 0 )
			return;
		 memset(wText,0,len);
		::MultiByteToWideChar(  CP_ACP, NULL,say, -1, wText,len );

		MessageBox(NULL,wText,L"demo",NULL);
		// when finish using wText dont forget to delete it
		delete []wText;
}


}

MT4_EXPFUNC void GetPassword(char *Prompt, int InputSize, char* returnString)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	CPasswordDialog dlg;
	dlg.m_strPrompt = CString(Prompt);
	dlg.m_nPasswordLength = InputSize;
	if (dlg.DoModal() == IDOK) {
		//if (dlg.m_strPassword.IsEmpty())
		//	return NULL;
		int nLength = dlg.m_strPassword.GetLength();
		char *output = new char[nLength+1];
		//dlg.m_strPassword.
		//returnString = (char *)(LPCTSTR)dlg.m_strPassword.GetBuffer(nLength);
		strncpy(returnString, (char *)(LPCTSTR)dlg.m_strPassword.GetBuffer(nLength), nLength);
		//output[nLength] = 0;
		//MessageBox(NULL,L"Test",L"demo",NULL);
		//return output;
	}

	//return NULL;
}

// CTestDialogBoxApp initialization

BOOL CTestDialogBoxApp::InitInstance()
{
	CWinApp::InitInstance();

	return TRUE;
}
