// PasswordDialog.cpp : implementation file
//

#include "stdafx.h"
#include "TestDialogBox.h"
#include "PasswordDialog.h"
#include "afxdialogex.h"


// CPasswordDialog dialog

IMPLEMENT_DYNAMIC(CPasswordDialog, CDialog)

CPasswordDialog::CPasswordDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CPasswordDialog::IDD, pParent)
	, m_strPassword(_T(""))
	, m_strPrompt(_T(""))
{

}

CPasswordDialog::~CPasswordDialog()
{
}

void CPasswordDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_PASSWORD, m_strPassword);
	DDV_MaxChars(pDX, m_strPassword, m_nPasswordLength);
	DDX_Text(pDX, IDC_PROMPT, m_strPrompt);
	DDV_MaxChars(pDX, m_strPrompt, 120);
}


BOOL CPasswordDialog::OnInitDialog()
{
	CDialog::OnInitDialog();
	GetDlgItem(IDC_PASSWORD)->SetFocus();

	return TRUE;
}
BEGIN_MESSAGE_MAP(CPasswordDialog, CDialog)
END_MESSAGE_MAP()


// CPasswordDialog message handlers
